//--redFrik 2014

RedAsciiMeter {
	var syn, osc;
	*new {|in= #[0, 1, 2, 3, 4, 5, 6, 7], width= 50, space= 100|
		^super.new.initRedAsciiMeter(in, width, space);
	}
	initRedAsciiMeter {|in, width, space|
		Server.default.waitForBoot{
			var inArray= in.asArray;
			SynthDef(\redAsciiMeter, {|atk= 0.01, rel= 0.1, lag= 0, fps= 60|
				var src= InFeedback.ar(\in.kr(inArray));
				var trk= Amplitude.kr(src, atk, rel).lag(lag);
				SendReply.kr(Impulse.kr(fps), '/redAsciiMeter', trk);
			}).add;
			Server.default.sync;
			syn= Synth(\redAsciiMeter, [\in, in], Server.default, \addToTail);
			osc= OSCFunc({|msg|
				var amps= msg[3..];
				var height= amps.size;
				var str= CollStream.on(String(space+(height*(width*2))));
				space.do{str<<Char.nl};
				amps.do{|a|
					(a.min(1)*width).asInteger.do{str<<$-};
					str<<$@;
					(a.max(1)-1*width).asInteger.do{str<<$X};
					str<<Char.nl;
				};
				str.contents.post;
			}, '/redAsciiMeter');
		};
	}
	stop {
		syn.free;
		osc.free;
	}
	in_ {|busses= #[0, 1, 2, 3, 4, 5, 6, 7]| syn.setn(\in, busses)}
	atk_ {|time= 0.01| syn.set(\atk, time)}
	rel_ {|time= 0.1| syn.set(\rel, time)}
	lag_ {|val= 0.1| syn.set(\lag, val)}
	fps_ {|val= 60| syn.set(\fps, val)}
}
