//--redFrik 2014

RedAsciiScope {
	var syn, osc, trails;
	*new {|in= 0, width= 50, height= 38, space= 25, trail= 20|
		^super.new.initRedAsciiScope(in, width, height, space, trail);
	}
	initRedAsciiScope {|in, width, height, space, trail|
		Server.default.waitForBoot{
			trails= List.fill(trail, {[0, 0]});
			SynthDef(\redAsciiScope, {|in= 0, lag= 0, fps= 60|
				var src= InFeedback.ar(in, 2).lag(lag).clip(-1, 1);
				SendReply.kr(Impulse.kr(fps), '/redAsciiScope', src);
			}).add;
			Server.default.sync;
			syn= Synth(\redAsciiScope, [\in, in], Server.default, \addToTail);
			osc= OSCFunc({|msg|
				var xy= (msg[3..4]*0.5+0.5*[width-1, height-1]).asInteger;
				var str= CollStream.on(String(space+(width+1*height)));
				space.do{str<<Char.nl};
				trails.pop;
				trails.addFirst(xy);
				height.do{|y|
					var t= trails.select{|xy| xy[1]==y};
					width.do{|x|
						if(t.any{|xy| xy[0]==x}, {
							str<<$*;
						}, {
							str<<Char.space;
						});
					};
					str<<Char.nl;
				};
				str.contents.post;
			}, '/redAsciiScope');
		};
	}
	stop {
		syn.free;
		osc.free;
	}
	in_ {|bus= 0| syn.set(\in, bus)}
	lag_ {|val= 0| syn.set(\lag, val)}
	fps_ {|val= 60| syn.set(\fps, val)}
}
