//--redFrik 2014

RedAsciiSpectrum {
	var syn, osc;
	*new {|in= 0, width= 50, height= 38, space= 25|
		^super.new.initRedAsciiSpectrum(in, width, height, space);
	}
	initRedAsciiSpectrum {|in, width, height, space|
		Server.default.waitForBoot{
			SynthDef(\redAsciiSpectrum, {|in= 0, atk= 0.01, rel= 0.3, min= 120, max= 12000, lag= 0.3, fps= 60|
				var src= Mix(InFeedback.ar(in, 2));
				var trk= {|i|
					var cf= (height-i).linexp(1, height, min, max);
					Amplitude.kr(
						BPF.ar(BPF.ar(src, cf, 0.1, 1.15), cf, 0.1, 1.15),
						atk,
						rel
					).lag(lag);
				}!height;
				SendReply.kr(Impulse.kr(fps), '/redAsciiSpectrum', trk);
			}).add;
			Server.default.sync;
			syn= Synth(\redAsciiSpectrum, [\in, in], Server.default, \addToTail);
			osc= OSCFunc({|msg|
				var amps= msg[3..];
				var str= CollStream.on(String(space+(height*(width*2))));
				space.do{str<<Char.nl};
				amps.do{|a|
					(a.min(1)*width).asInteger.do{str<<$-};
					str<<$@;
					(a.max(1)-1*width).asInteger.do{str<<$X};
					str<<Char.nl;
				};
				str.contents.post;
			}, '/redAsciiSpectrum');
		};
	}
	stop {
		syn.free;
		osc.free;
	}
	in_ {|bus= 0| syn.set(\in, bus)}
	atk_ {|time= 0.01| syn.set(\atk, time)}
	rel_ {|time= 0.2| syn.set(\rel, time)}
	min_ {|freq= 120| syn.set(\min, freq)}
	max_ {|freq= 12000| syn.set(\max, freq)}
	lag_ {|val= 0.3| syn.set(\lag, val)}
	fps_ {|val= 60| syn.set(\fps, val)}
}
